
Redmine - Feature #17720

Filter issues by "Updated by" and "Last updated by"

2014-08-21 12:51 - Scott Hildebrand

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: Issues filter Estimated time: 0.00 hour

Target version: 3.4.0   

Resolution: Fixed   

Description

There appears to be no good way to filter by involvement. I think that maybe there are 2 filters needed here.

updated by (this would be general involvement, other users could have updated an issue afterwards)

last updated by (this would be specifically to find issues by who touched it last)

Similarly I think that these need to be added as available columns.

BTW I did try this plugin (https://github.com/neowit/redmine_last_updated_by_column) but it was kind of broken, and I don't think it

quite addresses this general need.

Related issues:

Related to Redmine - Feature #17932: [Feature Request] History Assignee filter Closed

Related to Redmine - Feature #6375: Last updated by colum in issue list Closed 2010-09-12

Related to Redmine - Feature #10943: Query issues based on activity history New

Related to Redmine - Feature #10975: An 'Involved In' filter Resolved

Has duplicate Redmine - Feature #23210: "Updated by" filter is needed Closed

Has duplicate Redmine - Feature #1882: filter issues "modified by" a user Closed 2008-09-10

Has duplicate Redmine - Feature #13727: Search option  'updates made by me' Closed

Has duplicate Redmine - Feature #2333: Add ability to search for issues that ... Closed 2008-12-13

Associated revisions

Revision 16228 - 2017-01-19 21:16 - Jean-Philippe Lang

Adds updated_by and last_updated_by filters on issues (#17720).

Revision 16229 - 2017-01-19 21:22 - Jean-Philippe Lang

Adds :field_updated_by and :field_last_updated_by strings to locales (#17720).

Revision 16248 - 2017-01-21 11:37 - Jean-Philippe Lang

Changed filter position (#17720).

Patch by Go MAEDA.

History

#1 - 2014-08-25 05:54 - Lajish Lakshmanan

Hi Scott Hildebrand,

You are right, I also had the same problem. In redmine, there is no way to track who all users were involved in a tracker. Mostly developers who

resolves issues have to reassign tracker to author so that it get verified by same(i.e. tester). To handle this, I made a custom field called 'Resolved

By'.

I think, one of the problems you mentioned above can be handled by this plugin http://www.redmine.org/plugins/involvement_filter

But these features need to incorporated in Redmine core. I request Redmine team to consider these issues as soon as possible.

#2 - 2014-08-25 14:55 - Scott Hildebrand

Thanks Lajish! It seems to be working for version 2.4.2, except for some missing translations which is no biggie. This is the plugin for 2.x that I'm

using: https://github.com/commandprompt/redmine_involvement_filter
#3 - 2014-09-19 09:57 - Toshi MARUYAMA

- Category changed from Issues workflow to Issues

#4 - 2014-09-25 09:03 - Etienne Massip

- Related to Feature #17932: [Feature Request] History Assignee filter added

#5 - 2015-02-18 17:50 - Joel SCHAAL

+1

These 2 filters would make sense for us too.

For example: List all the open issues I have modified since "that day". We can have all the opened issues modified since "that day", but not the ones

(last) modified by a specific user.

#6 - 2015-07-14 11:17 - Janeks Kamerovskis

Are there any options for this filter "updated by" for Redmine v.3.x. ?

#7 - 2016-03-17 22:48 - Go MAEDA

- Related to Feature #6375: Last updated by colum in issue list added

#8 - 2016-06-30 17:54 - Toshi MARUYAMA

- Category changed from Issues to Issues filter

#9 - 2016-06-30 17:57 - Toshi MARUYAMA

- Has duplicate Feature #23210: "Updated by" filter is needed added

#10 - 2016-07-08 11:28 - Anonymous

+1

#11 - 2016-08-03 00:36 - Marius BĂLTEANU

- File filter_after_updated_by_and_last_updated_by.patch added

I made a patch (with tests) that adds these 2 useful filters:

1. updated_by: it can be used to find tickets updated or not by specific project users

Use case: Find all the tickets that have been updated (touched) by me.

2. last_updated_by: it can be used to find tickets that were last updated or not by specific users

Use case: Find all the tickets that have been last updated by user x (a customer for example).

Both filters apply only on issues with at least one update made after issue creation.

Because the "last_updated_by" filter expects that the issue updated_on date to be equal with last journal created_on date, it was required to make

some changes to issues fixtures and journal fixtures in order to match the dates. If i'm wrong with this expectation, please let me know and I'll try to

find another solution.

Also, I've added a new journal entry in journal fixtures to test a scenario (with "!" operator). Because of this new journal entry, I changed in issue_test

the issue id of the ticket without journals.

I'll add another patch that implements the last_updated_by as column in #6375.

#12 - 2016-08-04 03:51 - Go MAEDA

- Priority changed from High to Normal

- Target version set to 3.4.0

Thanks for submitting the patch, Marius BALTEANU. This is very useful.

It works fine for me and passed all tests. Setting target version to 3.4.0.

#13 - 2016-10-09 12:57 - Marius BĂLTEANU

- File filter_after_updated_by_and_last_updated_by_v2.patch added

Updated the patch to cleanly apply on the current trunk. All the tests pass.
#14 - 2016-11-07 13:10 - Toshi MARUYAMA

- File filter_after_updated_by_and_last_updated_by_v3.patch added

Rebased on r15949 v2 patch with minor fix.

diff --git a/test/unit/query_test.rb b/test/unit/query_test.rb

--- a/test/unit/query_test.rb

+++ b/test/unit/query_test.rb

@@ -29,7 +29,7 @@

            :queries,

            :projects_trackers,

            :custom_fields_trackers,

-           :workflows

+           :workflows, :journals

#15 - 2016-12-11 13:38 - Go MAEDA

- Has duplicate Feature #1882: filter issues "modified by" a user added

#16 - 2017-01-16 19:21 - Marius BĂLTEANU

- File filter_after_updated_by_and_last_updated_by_v4.patch added

Updated the patch to cleanly apply on the current trunk.

@Jean-Philippe Lang, is there anything I can do in order to have this committed?

#17 - 2017-01-16 19:27 - Jean-Philippe Lang

- Status changed from New to Needs feedback

For users who are not allowed to view private notes, these filters can match issues even if the update is not visible to the user.

Eg. user A updates issue X with private notes, user B (who is not allowed to view private notes) filters issues updated by user A and sees issue X in

the results. But he won't see any update by user A when looking at the issue history.

Is it an acceptable behaviour?

#18 - 2017-01-16 20:42 - Marius BĂLTEANU

- File updated.png added

Jean-Philippe Lang wrote:

For users who are not allowed to view private notes, these filters can match issues even if the update is not visible to the user.

Eg. user A updates issue X with private notes, user B (who is not allowed to view private notes) filters issues updated by user A and sees issue

X in the results. But he won't see any update by user A when looking at the issue history.

Is it an acceptable behaviour?

 Very good question :)

From my point of view, this is an acceptable behaviour because the privacy of the note is not affected. User B it'll see only that the issue X was

updated by user A. Currently, you can see the last update date, but without seeing the respective update in the history:

 updated.png 

In the same time, I agree that the behaviour can be a little bit confusing for the users.

My proposal is to implement them as it is and see if the users will complain about it.

#19 - 2017-01-16 22:39 - Marius BĂLTEANU

Because I've mix feelings about my previous proposal, I'm going to take some feedback this week from our users regarding the expected behavior.

#20 - 2017-01-19 19:56 - Marius BĂLTEANU

I don't have a clear resolution after the feedback received, some of our users consider the behavior acceptable, and others agree that can be a little

bit confusing.

Considering that is quite complex to ignore the private updates depending on the user permissions (with my Ruby/Redmine skills), and that the
chances to find the issues updated by A to which user B doesn't have access are low, I think it is an acceptable behavior at least in the first phase.

#21 - 2017-01-19 21:24 - Jean-Philippe Lang

- Subject changed from Need to be able to filter by "updated by" to Filter issues by "Updated by" and "Last updated by"

- Status changed from Needs feedback to Closed

- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

Thanks for your feedback Marius.

I think hiding private updates is a better option and was not so difficult to implement without too much changes. It's committed in r16228. I've made a

few tests with Postgres and 1M journals without performance issues. Please let know how it works for you.

#22 - 2017-01-21 11:18 - Go MAEDA

- File filter-position-before.png added

- File filter-position-after.png added

- File 17720-change-filter-position.diff added

- Status changed from Closed to Reopened

Sorry for reopening this issue.

I think it would be better to change the position of "Updated by" and "Last updated by" in the filters drop-down. Here is a patch: 

17720-change-filter-position.diff

Please see the following images for details.

Before (current implementation):

 

After:
#23 - 2017-01-21 11:37 - Jean-Philippe Lang

- Status changed from Reopened to Closed

Committed, thanks.

#24 - 2017-01-22 07:50 - Go MAEDA

- Has duplicate Feature #13727: Search option  'updates made by me' added

#25 - 2017-01-22 13:00 - Marius BĂLTEANU

Jean-Philippe Lang wrote:

I think hiding private updates is a better option and was not so difficult to implement without too much changes. It's committed in r16228. I've

made a few tests with Postgres and 1M journals without performance issues. Please let know how it works for you.

 Thanks for committing this new filters and for the journal visibility implementation. I test it and it works great for us. Unfortunately, I don't have a large

MySQL database for tests, but I'll let you know if we have any performance issue on our instance after 3.4.0 release.

Speaking about 3.4.0 and a little bit off-topic, do you have any estimation about the release date? There are a lot of great features already committed

:).

#26 - 2017-04-02 03:48 - Go MAEDA

- Has duplicate Feature #2333: Add ability to search for issues that the user touched added

#27 - 2017-10-29 05:08 - Go MAEDA

- Related to Feature #10943: Query issues based on activity history added

#28 - 2018-06-06 10:55 - Go MAEDA

- Related to Feature #10975: An 'Involved In' filter added

Files

filter_after_updated_by_and_last_updated_by.patch 14.8 KB 2016-08-02 Marius BĂLTEANU

filter_after_updated_by_and_last_updated_by_v2.patch 13.9 KB 2016-10-09 Marius BĂLTEANU

filter_after_updated_by_and_last_updated_by_v3.patch 7.59 KB 2016-11-07 Toshi MARUYAMA

filter_after_updated_by_and_last_updated_by_v4.patch 7.02 KB 2017-01-16 Marius BĂLTEANU

updated.png 27.4 KB 2017-01-16 Marius BĂLTEANU

filter-position-before.png 17.3 KB 2017-01-21 Go MAEDA

filter-position-after.png 17.9 KB 2017-01-21 Go MAEDA
17720-change-filter-position.diff 1.04 KB 2017-01-21 Go MAEDA
